### Method

# Gck Session decrypt_full

#### Declaration [src]

    guchar*
    gck_session_decrypt_full (
      GckSession* self,
      GckObject* key,
      GckMechanism* mechanism,
      const guchar* input,
      gsize n_input,
      gsize* n_result,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Decrypt data in a mechanism specific manner. This call may block for an indefinite period.

#### Parameters

`key`

  Type: `GckObject`

  The key to decrypt with.

  The data is owned by the caller of the function.

`mechanism`

  Type: `GckMechanism`

  The mechanism type and parameters to use for decryption.

  The data is owned by the caller of the function.

`input`

  Type: An array of `guchar`

  Data to decrypt.

  The length of the array is specified in the `n_input` argument.
  The data is owned by the caller of the function.

`n_input`

  Type: `gsize`

  Length of the data to decrypt.

`n_result`

  Type: `gsize*`

  Location to store the length of the result data.

  The argument will be set by the function.

`cancellable`

  Type: `GCancellable`

  A GCancellable which can be used to cancel the operation.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: An array of `guchar`

The data that was decrypted, or `NULL` if an error occured.

The length of the array is in the `n_result` argument.
The caller of the method takes ownership of the data, and is responsible for freeing it.